#include <math.h>
#include <vector>
#include <iostream>
#include <string.h>
#include <curl/curl.h>

#include "histogram.h"
#include "text.h"
#include "svg.h"


using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    float n;
};

Input
input_data(istream& in,bool prompt) {
    string a, b, c;
    if(prompt== true){
    a = "Enter number count:";
    b = "Enter numbers:";
    c = "Enter bin count:";
    }
    size_t number_count;
    cerr << a;
    in >> number_count;

    Input on;
    on.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cerr << b << i+1 << ": ";
        in >> on.numbers[i];}
    cerr << c;
    in >> on.bin_count;

    on.n = 0;
    if (on.bin_count==0){
        on.bin_count = sqrt(number_count);
        on.n = 1;
        if (on.bin_count > 25){
            on.bin_count = 1 + log2(number_count);
            on.n = 2;}}

    return on;
}



int main(int argc, char* argv[])
{
    if (argc > 1) {
        cerr << "argv[0] = " << argv[0] <<'\n';
        cerr << "argc = " << argc;
        return 0;}

    curl_global_init(CURL_GLOBAL_ALL);

    auto in = input_data(cin,true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
